
#include <err.h>
#include <stdio.h>


#include <abac_pl.h>

#include "options.h"

extern void abac_print_cred_info(abac_credential_t *);

int main(int argc, char **argv) {
    int i, success;
    abac_credential_t *cred;

    options_t opts = { 0, };
    get_options(argc, argv, &opts);
    abac_context_t *ctx = abac_context_new();
    abac_context_load_directory(ctx, opts.keystore);
    abac_credential_t **credentials = abac_context_query(ctx,
        opts.role, opts.principal,
        &success
    );
    if (success)
        puts("prover success!!");

    if (credentials != NULL)
        puts("credentials needed :");
        for (i = 0; credentials[i] != NULL; ++i) {
            cred = credentials[i];
            abac_print_cred_info(cred);
        }

    abac_context_credentials_free(credentials);
    abac_context_free(ctx);

    return 0;
}
